#include <kdialog.h>
#include <klocale.h>

#ifndef UI_BGADVANCEDBASE_H
#define UI_BGADVANCEDBASE_H

#include <qvariant.h>


#include <Qt3Support/Q3ButtonGroup>
#include <Qt3Support/Q3GroupBox>
#include <Qt3Support/Q3Header>
#include <Qt3Support/Q3ListView>
#include <Qt3Support/Q3MimeSourceFactory>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QCheckBox>
#include <QtGui/QGridLayout>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QPushButton>
#include <QtGui/QSpacerItem>
#include <QtGui/QSpinBox>
#include <QtGui/QVBoxLayout>
#include <QtGui/QWidget>
#include "kcolorbutton.h"

class Ui_BGAdvancedBase
{
public:
    QVBoxLayout *vboxLayout;
    Q3ButtonGroup *m_groupProgram;
    QGridLayout *gridLayout;
    QPushButton *m_buttonAdd;
    QPushButton *m_buttonRemove;
    QPushButton *m_buttonModify;
    QSpacerItem *spacerItem;
    Q3ListView *m_listPrograms;
    QCheckBox *m_cbProgram;
    Q3GroupBox *m_groupIconText;
    QGridLayout *gridLayout1;
    KColorButton *m_colorText;
    QLabel *textLabel6;
    QSpacerItem *spacerItem1;
    KColorButton *m_colorTextBackground;
    QCheckBox *m_cbSolidTextBackground;
    QCheckBox *m_cbShadow;
    QLabel *textLabel6_2;
    QSpinBox *m_spinTextLines;
    QSpinBox *m_spinTextWidth;
    QLabel *textLabel6_2_2;
    Q3ButtonGroup *m_groupCache;
    QHBoxLayout *hboxLayout;
    QLabel *m_lblCache;
    QSpinBox *m_spinCache;
    QSpacerItem *spacerItem2;
    QSpacerItem *spacerItem3;

    void setupUi(QWidget *BGAdvancedBase)
    {
    if (BGAdvancedBase->objectName().isEmpty())
        BGAdvancedBase->setObjectName(QString::fromUtf8("BGAdvancedBase"));
    BGAdvancedBase->resize(511, 454);
    vboxLayout = new QVBoxLayout(BGAdvancedBase);
    vboxLayout->setSpacing(KDialog::spacingHint());
    vboxLayout->setMargin(0);
    vboxLayout->setObjectName(QString::fromUtf8("vboxLayout"));
    m_groupProgram = new Q3ButtonGroup(BGAdvancedBase);
    m_groupProgram->setObjectName(QString::fromUtf8("m_groupProgram"));
    m_groupProgram->setColumnLayout(0, Qt::Vertical);
    m_groupProgram->layout()->setSpacing(KDialog::spacingHint());
    m_groupProgram->layout()->setMargin(11);
    gridLayout = new QGridLayout();
    QBoxLayout *boxlayout = qobject_cast<QBoxLayout *>(m_groupProgram->layout());
    if (boxlayout)
        boxlayout->addLayout(gridLayout);
    gridLayout->setAlignment(Qt::AlignTop);
    gridLayout->setObjectName(QString::fromUtf8("gridLayout"));
    m_buttonAdd = new QPushButton(m_groupProgram);
    m_buttonAdd->setObjectName(QString::fromUtf8("m_buttonAdd"));
    m_buttonAdd->setEnabled(false);

    gridLayout->addWidget(m_buttonAdd, 1, 1, 1, 1);

    m_buttonRemove = new QPushButton(m_groupProgram);
    m_buttonRemove->setObjectName(QString::fromUtf8("m_buttonRemove"));
    m_buttonRemove->setEnabled(false);

    gridLayout->addWidget(m_buttonRemove, 2, 1, 1, 1);

    m_buttonModify = new QPushButton(m_groupProgram);
    m_buttonModify->setObjectName(QString::fromUtf8("m_buttonModify"));
    m_buttonModify->setEnabled(false);

    gridLayout->addWidget(m_buttonModify, 3, 1, 1, 1);

    spacerItem = new QSpacerItem(20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    gridLayout->addItem(spacerItem, 4, 1, 1, 1);

    m_listPrograms = new Q3ListView(m_groupProgram);
    m_listPrograms->addColumn(tr2i18n("Program", 0));
    m_listPrograms->header()->setClickEnabled(true, m_listPrograms->header()->count() - 1);
    m_listPrograms->header()->setResizeEnabled(true, m_listPrograms->header()->count() - 1);
    m_listPrograms->addColumn(tr2i18n("Comment", 0));
    m_listPrograms->header()->setClickEnabled(true, m_listPrograms->header()->count() - 1);
    m_listPrograms->header()->setResizeEnabled(true, m_listPrograms->header()->count() - 1);
    m_listPrograms->addColumn(tr2i18n("Refresh", 0));
    m_listPrograms->header()->setClickEnabled(true, m_listPrograms->header()->count() - 1);
    m_listPrograms->header()->setResizeEnabled(true, m_listPrograms->header()->count() - 1);
    m_listPrograms->setObjectName(QString::fromUtf8("m_listPrograms"));
    m_listPrograms->setEnabled(false);
    m_listPrograms->setMinimumSize(QSize(400, 0));

    gridLayout->addWidget(m_listPrograms, 1, 0, 4, 1);

    m_cbProgram = new QCheckBox(m_groupProgram);
    m_cbProgram->setObjectName(QString::fromUtf8("m_cbProgram"));

    gridLayout->addWidget(m_cbProgram, 0, 0, 1, 2);


    vboxLayout->addWidget(m_groupProgram);

    m_groupIconText = new Q3GroupBox(BGAdvancedBase);
    m_groupIconText->setObjectName(QString::fromUtf8("m_groupIconText"));
    m_groupIconText->setColumnLayout(0, Qt::Vertical);
    m_groupIconText->layout()->setSpacing(KDialog::spacingHint());
    m_groupIconText->layout()->setMargin(KDialog::marginHint());
    gridLayout1 = new QGridLayout();
    QBoxLayout *boxlayout1 = qobject_cast<QBoxLayout *>(m_groupIconText->layout());
    if (boxlayout1)
        boxlayout1->addLayout(gridLayout1);
    gridLayout1->setAlignment(Qt::AlignTop);
    gridLayout1->setObjectName(QString::fromUtf8("gridLayout1"));
    m_colorText = new KColorButton(m_groupIconText);
    m_colorText->setObjectName(QString::fromUtf8("m_colorText"));
    QSizePolicy sizePolicy(static_cast<QSizePolicy::Policy>(1), static_cast<QSizePolicy::Policy>(0));
    sizePolicy.setHorizontalStretch(0);
    sizePolicy.setVerticalStretch(0);
    sizePolicy.setHeightForWidth(m_colorText->sizePolicy().hasHeightForWidth());
    m_colorText->setSizePolicy(sizePolicy);

    gridLayout1->addWidget(m_colorText, 0, 1, 1, 1);

    textLabel6 = new QLabel(m_groupIconText);
    textLabel6->setObjectName(QString::fromUtf8("textLabel6"));
    textLabel6->setWordWrap(false);

    gridLayout1->addWidget(textLabel6, 0, 0, 1, 1);

    spacerItem1 = new QSpacerItem(220, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    gridLayout1->addItem(spacerItem1, 0, 2, 2, 1);

    m_colorTextBackground = new KColorButton(m_groupIconText);
    m_colorTextBackground->setObjectName(QString::fromUtf8("m_colorTextBackground"));
    m_colorTextBackground->setEnabled(false);

    gridLayout1->addWidget(m_colorTextBackground, 1, 1, 1, 1);

    m_cbSolidTextBackground = new QCheckBox(m_groupIconText);
    m_cbSolidTextBackground->setObjectName(QString::fromUtf8("m_cbSolidTextBackground"));

    gridLayout1->addWidget(m_cbSolidTextBackground, 1, 0, 1, 1);

    m_cbShadow = new QCheckBox(m_groupIconText);
    m_cbShadow->setObjectName(QString::fromUtf8("m_cbShadow"));

    gridLayout1->addWidget(m_cbShadow, 2, 0, 1, 1);

    textLabel6_2 = new QLabel(m_groupIconText);
    textLabel6_2->setObjectName(QString::fromUtf8("textLabel6_2"));
    textLabel6_2->setWordWrap(false);

    gridLayout1->addWidget(textLabel6_2, 3, 0, 1, 1);

    m_spinTextLines = new QSpinBox(m_groupIconText);
    m_spinTextLines->setObjectName(QString::fromUtf8("m_spinTextLines"));
    m_spinTextLines->setValue(0);

    gridLayout1->addWidget(m_spinTextLines, 3, 1, 1, 1);

    m_spinTextWidth = new QSpinBox(m_groupIconText);
    m_spinTextWidth->setObjectName(QString::fromUtf8("m_spinTextWidth"));
    m_spinTextWidth->setMaximum(99999);
    m_spinTextWidth->setValue(0);

    gridLayout1->addWidget(m_spinTextWidth, 4, 1, 1, 1);

    textLabel6_2_2 = new QLabel(m_groupIconText);
    textLabel6_2_2->setObjectName(QString::fromUtf8("textLabel6_2_2"));
    textLabel6_2_2->setWordWrap(false);

    gridLayout1->addWidget(textLabel6_2_2, 4, 0, 1, 1);


    vboxLayout->addWidget(m_groupIconText);

    m_groupCache = new Q3ButtonGroup(BGAdvancedBase);
    m_groupCache->setObjectName(QString::fromUtf8("m_groupCache"));
    m_groupCache->setColumnLayout(0, Qt::Vertical);
    m_groupCache->layout()->setSpacing(KDialog::spacingHint());
    m_groupCache->layout()->setMargin(11);
    hboxLayout = new QHBoxLayout();
    QBoxLayout *boxlayout2 = qobject_cast<QBoxLayout *>(m_groupCache->layout());
    if (boxlayout2)
        boxlayout2->addLayout(hboxLayout);
    hboxLayout->setAlignment(Qt::AlignTop);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    m_lblCache = new QLabel(m_groupCache);
    m_lblCache->setObjectName(QString::fromUtf8("m_lblCache"));
    m_lblCache->setWordWrap(false);

    hboxLayout->addWidget(m_lblCache);

    m_spinCache = new QSpinBox(m_groupCache);
    m_spinCache->setObjectName(QString::fromUtf8("m_spinCache"));

    hboxLayout->addWidget(m_spinCache);

    spacerItem2 = new QSpacerItem(20, 20, QSizePolicy::Expanding, QSizePolicy::Minimum);

    hboxLayout->addItem(spacerItem2);


    vboxLayout->addWidget(m_groupCache);

    spacerItem3 = new QSpacerItem(20, 16, QSizePolicy::Expanding, QSizePolicy::Minimum);

    vboxLayout->addItem(spacerItem3);

    textLabel6->setBuddy(m_colorText);
    textLabel6_2->setBuddy(m_colorText);
    textLabel6_2_2->setBuddy(m_colorText);
    QWidget::setTabOrder(m_cbProgram, m_listPrograms);
    QWidget::setTabOrder(m_listPrograms, m_buttonAdd);
    QWidget::setTabOrder(m_buttonAdd, m_buttonRemove);
    QWidget::setTabOrder(m_buttonRemove, m_buttonModify);
    QWidget::setTabOrder(m_buttonModify, m_colorText);
    QWidget::setTabOrder(m_colorText, m_cbSolidTextBackground);
    QWidget::setTabOrder(m_cbSolidTextBackground, m_colorTextBackground);
    QWidget::setTabOrder(m_colorTextBackground, m_cbShadow);
    QWidget::setTabOrder(m_cbShadow, m_spinCache);

    retranslateUi(BGAdvancedBase);
    QObject::connect(m_cbProgram, SIGNAL(toggled(bool)), m_buttonAdd, SLOT(setEnabled(bool)));
    QObject::connect(m_cbProgram, SIGNAL(toggled(bool)), m_buttonRemove, SLOT(setEnabled(bool)));
    QObject::connect(m_cbProgram, SIGNAL(toggled(bool)), m_buttonModify, SLOT(setEnabled(bool)));
    QObject::connect(m_cbProgram, SIGNAL(toggled(bool)), m_listPrograms, SLOT(setEnabled(bool)));
    QObject::connect(m_cbSolidTextBackground, SIGNAL(toggled(bool)), m_colorTextBackground, SLOT(setEnabled(bool)));

    QMetaObject::connectSlotsByName(BGAdvancedBase);
    } // setupUi

    void retranslateUi(QWidget *BGAdvancedBase)
    {
    m_groupProgram->setTitle(tr2i18n("Background Program", 0));
    m_buttonAdd->setText(tr2i18n("&Add...", 0));
    m_buttonAdd->setProperty("whatsThis", QVariant(tr2i18n("<qt>\n"
"<p>Click here if you want to add a program to the listbox. This button opens a dialog where you are asked to give details about the program you want to run. To successfully add a program, you must know if it is compatible, the name of the executable file and, if necessary, its options.</p>\n"
"<p>You usually can get the available options to a suitable program by typing in a terminal emulator the name of the executable file plus --help (foobar --help).</p>\n"
"</qt>", 0)));
    m_buttonRemove->setText(tr2i18n("&Remove", 0));
    m_buttonRemove->setProperty("whatsThis", QVariant(tr2i18n("Click here to remove programs from this list. Please note that it does not remove the program from your system, it only removes it from the available options in the background drawing programs list.", 0)));
    m_buttonModify->setText(tr2i18n("&Modify...", 0));
    m_buttonModify->setProperty("whatsThis", QVariant(tr2i18n("<qt>\n"
"<p>Click here to modify the programs options. You usually can get the available options to a suitable program by typing in a terminal emulator the name of the executable file plus --help. (example: kwebdesktop --help).</p>\n"
"<p>One useful example is the program kwebdesktop. It draws a web page on the background of your desktop.  You can use this program by selecting it on the listbox on the right, but it will draw a predefined web page. To change the web page it renders, select the kwebdesktop program on the listbox, then click here. A dialog will appear, allowing you to change the web page by replacing the old address (URL) with a new one.</p>\n"
"</qt>", 0)));
    m_listPrograms->header()->setLabel(0, tr2i18n("Program", 0));
    m_listPrograms->header()->setLabel(1, tr2i18n("Comment", 0));
    m_listPrograms->header()->setLabel(2, tr2i18n("Refresh", 0));
    m_listPrograms->setProperty("whatsThis", QVariant(tr2i18n("<qt>\n"
"<p>Select from this listbox the program you want to use to draw your desktop background.</p>\n"
"<p>The <b>Program</b> column shows the name of the program.<br>\n"
"The <b>Comment</b> column brings a short description.<br>\n"
"The <b>Refresh</b> column indicates the time interval between redraws of the desktop.</p>\n"
"<p>The <b>K Web Desktop</b> program (kwebdesktop) is worth noting: it draws a specified page of the web in your desktop. You can modify it, and the webpage it draws by selecting it here, then clicking on the <b>Modify</b> button.<br>\n"
"You can also add new compliant programs. To do that, click on the <b>Add</b> button.<br>\n"
"You can also remove programs from this list clicking on the <b>Remove</b> button. Please note that it does not remove the program from your system, it only removes it from the available options in this listbox.</p>\n"
"</qt>", 0)));
    m_cbProgram->setText(tr2i18n("Use the following program for drawing the background:", 0));
    m_cbProgram->setProperty("whatsThis", QVariant(tr2i18n("Check here if you want to allow a program to draw your desktop background. Below you can find the list of programs currently available for drawing the background. You may use one of the available programs, add new ones or modify the existing ones to fit your needs.", 0)));
    m_groupIconText->setTitle(tr2i18n("Background Icon Text", 0));
    m_colorText->setText(QString());
    m_colorText->setProperty("whatsThis", QVariant(tr2i18n("Click here to change the color of the desktop font.", 0)));
    textLabel6->setText(tr2i18n("&Text color:", 0));
    textLabel6->setProperty("whatsThis", QVariant(tr2i18n("Click here to change the color of the desktop font.", 0)));
    m_colorTextBackground->setText(QString());
    m_colorTextBackground->setProperty("whatsThis", QVariant(tr2i18n("Click here to select the solid background color. Choose a different color from the background text color to assure readability.", 0)));
    m_cbSolidTextBackground->setText(tr2i18n("&Use solid color behind text:", 0));
    m_cbSolidTextBackground->setProperty("whatsThis", QVariant(tr2i18n("Check here if you want to use a solid background color. This is useful to ensure that the desktop text will be identifiable against all background colors and wallpapers, or in other words, that a background or wallpaper will not make a desktop text of a similar color difficult to read.", 0)));
    m_cbShadow->setText(tr2i18n("&Enable shadow", 0));
    m_cbShadow->setProperty("whatsThis", QVariant(tr2i18n("Check here to enable a shadow outline around the desktop font. This also improves the readability of the desktop text against backgrounds of a similar color.", 0)));
    textLabel6_2->setText(tr2i18n("&Lines for icon text:", 0));
    textLabel6_2->setProperty("whatsThis", QVariant(tr2i18n("Choose here the maximum number of text lines below an icon on the desktop. Longer text will be truncated at the end of the last line.", 0)));
    m_spinTextLines->setSuffix(QString());
    m_spinTextLines->setProperty("whatsThis", QVariant(tr2i18n("Choose here the maximum number of text lines below an icon on the desktop. Longer text will be truncated at the end of the last line.", 0)));
    m_spinTextWidth->setSuffix(QString());
    m_spinTextWidth->setSpecialValueText(tr2i18n("Auto", 0));
    m_spinTextWidth->setProperty("whatsThis", QVariant(tr2i18n("Choose here the maximum width of text lines (in pixel) below an icon on the desktop. If set to 'Auto' a default width based on the current font is used.", 0)));
    textLabel6_2_2->setText(tr2i18n("&Width for icon text:", 0));
    textLabel6_2_2->setProperty("whatsThis", QVariant(tr2i18n("Choose here the maximum width of text lines (in pixel) below an icon on the desktop. If set to 'Auto' a default width based on the current font is used.", 0)));
    m_groupCache->setTitle(tr2i18n("Memory Usage", 0));
    m_lblCache->setText(tr2i18n("Size of background cache:", 0));
    m_lblCache->setProperty("whatsThis", QVariant(tr2i18n("In this box you can enter how much memory KDE should use for caching the background(s). If you have different backgrounds for the different desktops caching can make switching desktops smoother at the expense of higher memory use.", 0)));
    m_spinCache->setSuffix(tr2i18n(" k", 0));
    m_spinCache->setProperty("whatsThis", QVariant(tr2i18n("In this box you can enter how much memory KDE should use for caching the background(s). If you have different backgrounds for the different desktops caching can make switching desktops smoother at the expense of higher memory use.", 0)));
    Q_UNUSED(BGAdvancedBase);
    } // retranslateUi

};

namespace Ui {
    class BGAdvancedBase: public Ui_BGAdvancedBase {};
} // namespace Ui

class BGAdvancedBase : public QWidget, public Ui::BGAdvancedBase
{
    Q_OBJECT

public:
    BGAdvancedBase(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = 0);
    ~BGAdvancedBase();

protected slots:
    virtual void languageChange();

};

#endif // BGADVANCEDBASE_H

