#include <kdialog.h>
#include <klocale.h>

#ifndef UI_FORM1_H
#define UI_FORM1_H

#include <qvariant.h>


#include <Qt3Support/Q3MimeSourceFactory>
#include <QtCore/QVariant>
#include <QtGui/QAction>
#include <QtGui/QApplication>
#include <QtGui/QButtonGroup>
#include <QtGui/QHBoxLayout>
#include <QtGui/QLabel>
#include <QtGui/QWidget>
#include "kpushbutton.h"

class Ui_Voice_input_widget_ui
{
public:
    QHBoxLayout *hboxLayout;
    QLabel *label;
    KPushButton *buttonPlay;
    KPushButton *buttonRecord;
    KPushButton *buttonStop;

    void setupUi(QWidget *Form1)
    {
    if (Form1->objectName().isEmpty())
        Form1->setObjectName(QString::fromUtf8("Form1"));
    Form1->resize(486, 51);
    hboxLayout = new QHBoxLayout(Form1);
    hboxLayout->setSpacing(6);
    hboxLayout->setMargin(11);
    hboxLayout->setObjectName(QString::fromUtf8("hboxLayout"));
    label = new QLabel(Form1);
    label->setObjectName(QString::fromUtf8("label"));
    QSizePolicy sizePolicy(static_cast<QSizePolicy::Policy>(7), static_cast<QSizePolicy::Policy>(5));
    sizePolicy.setHorizontalStretch(0);
    sizePolicy.setVerticalStretch(0);
    sizePolicy.setHeightForWidth(label->sizePolicy().hasHeightForWidth());
    label->setSizePolicy(sizePolicy);
    label->setMinimumSize(QSize(150, 0));
    label->setWordWrap(false);

    hboxLayout->addWidget(label);

    buttonPlay = new KPushButton(Form1);
    buttonPlay->setObjectName(QString::fromUtf8("buttonPlay"));

    hboxLayout->addWidget(buttonPlay);

    buttonRecord = new KPushButton(Form1);
    buttonRecord->setObjectName(QString::fromUtf8("buttonRecord"));

    hboxLayout->addWidget(buttonRecord);

    buttonStop = new KPushButton(Form1);
    buttonStop->setObjectName(QString::fromUtf8("buttonStop"));

    hboxLayout->addWidget(buttonStop);


    retranslateUi(Form1);
    QObject::connect(buttonRecord, SIGNAL(pressed()), Form1, SLOT(slotRecordPressed()));
    QObject::connect(buttonStop, SIGNAL(pressed()), Form1, SLOT(slotStopPressed()));
    QObject::connect(buttonPlay, SIGNAL(pressed()), Form1, SLOT(slotPlayPressed()));

    QMetaObject::connectSlotsByName(Form1);
    } // setupUi

    void retranslateUi(QWidget *Form1)
    {
    label->setText(QString());
    buttonPlay->setText(tr2i18n("&Play", 0));
    buttonRecord->setText(tr2i18n("&Record", 0));
    buttonStop->setText(tr2i18n("&Stop", 0));
    Q_UNUSED(Form1);
    } // retranslateUi

};

namespace Ui {
    class Voice_input_widget_ui: public Ui_Voice_input_widget_ui {};
} // namespace Ui

class Voice_input_widget_ui : public QWidget, public Ui::Voice_input_widget_ui
{
    Q_OBJECT

public:
    Voice_input_widget_ui(QWidget* parent = 0, const char* name = 0, Qt::WindowFlags fl = 0);
    ~Voice_input_widget_ui();

protected slots:
    virtual void languageChange();

    virtual void slotRecordPressed() = 0;
    virtual void slotPlayPressed() = 0;
    virtual void slotStopPressed() = 0;


};

#endif // FORM1_H

