// This file is generated by kconfig_compiler from krunner.kcfg.
// All changes you do to this file will be lost.
#ifndef KRUNNERSETTINGS_H
#define KRUNNERSETTINGS_H

#include <kconfigskeleton.h>
#include <kdebug.h>

#include <ProcessModel.h>
#include <ProcessFilter.h>
class KRunnerSettings : public KConfigSkeleton
{
  public:

    static KRunnerSettings *self();
    ~KRunnerSettings();

    /**
      Set Whitelist of allowed runners.
    */
    static
    void setRunners( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "runners" ) ))
        self()->mRunners = v;
    }

    /**
      Get Whitelist of allowed runners.
    */
    static
    QStringList runners()
    {
      return self()->mRunners;
    }

    /**
      Set History if past queries succesfully completed
    */
    static
    void setPastQueries( const QStringList & v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "PastQueries" ) ))
        self()->mPastQueries = v;
    }

    /**
      Get History if past queries succesfully completed
    */
    static
    QStringList pastQueries()
    {
      return self()->mPastQueries;
    }

    /**
      Set Maximum number of query matching threads able run simultaneously.
    */
    static
    void setMaxThreads( int v )
    {
      if (v < 1)
      {
        kDebug() << "setMaxThreads: value " << v << " is less than the minimum value of 1" << endl;
        v = 1;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "MaxThreads" ) ))
        self()->mMaxThreads = v;
    }

    /**
      Get Maximum number of query matching threads able run simultaneously.
    */
    static
    int maxThreads()
    {
      return self()->mMaxThreads;
    }

    /**
      Set Whether to keep the tasks dialog above other windows when shown.
    */
    static
    void setKeepTaskDialogAbove( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "KeepTaskDialogAbove" ) ))
        self()->mKeepTaskDialogAbove = v;
    }

    /**
      Get Whether to keep the tasks dialog above other windows when shown.
    */
    static
    bool keepTaskDialogAbove()
    {
      return self()->mKeepTaskDialogAbove;
    }

    /**
      Set units
    */
    static
    void setUnits( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "units" ) ))
        self()->mUnits = v;
    }

    /**
      Get units
    */
    static
    int units()
    {
      return self()->mUnits;
    }

    /**
      Set showTotals
    */
    static
    void setShowTotals( bool v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "showTotals" ) ))
        self()->mShowTotals = v;
    }

    /**
      Get showTotals
    */
    static
    bool showTotals()
    {
      return self()->mShowTotals;
    }

    /**
      Set filterState
    */
    static
    void setFilterState( int v )
    {
      if (!self()->isImmutable( QString::fromLatin1 ( "filterState" ) ))
        self()->mFilterState = v;
    }

    /**
      Get filterState
    */
    static
    int filterState()
    {
      return self()->mFilterState;
    }

    /**
      Set updateIntervalMSecs
    */
    static
    void setUpdateIntervalMSecs( int v )
    {
      if (v < 0)
      {
        kDebug() << "setUpdateIntervalMSecs: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "updateIntervalMSecs" ) ))
        self()->mUpdateIntervalMSecs = v;
    }

    /**
      Get updateIntervalMSecs
    */
    static
    int updateIntervalMSecs()
    {
      return self()->mUpdateIntervalMSecs;
    }

    /**
      Set version
    */
    static
    void setVersion( int v )
    {
      if (v < 0)
      {
        kDebug() << "setVersion: value " << v << " is less than the minimum value of 0" << endl;
        v = 0;
      }
      if (!self()->isImmutable( QString::fromLatin1 ( "version" ) ))
        self()->mVersion = v;
    }

    /**
      Get version
    */
    static
    int version()
    {
      return self()->mVersion;
    }

  protected:
    KRunnerSettings();
    friend class KRunnerSettingsHelper;


    // General
    QStringList mRunners;
    QStringList mPastQueries;
    int mMaxThreads;

    // TaskDialog
    bool mKeepTaskDialogAbove;
    int mUnits;
    bool mShowTotals;
    int mFilterState;
    int mUpdateIntervalMSecs;
    int mVersion;

  private:
};

#endif

